"{ Package: 'stx:goodies/refactoryBrowser/changes' }"

"{ NameSpace: Smalltalk }"

RefactoryClassChange subclass:#RemoveMethodChange
	instanceVariableNames:'selector'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Change Objects'
!


!RemoveMethodChange class methodsFor:'instance creation'!

remove: aSymbol from: aClass 
	^(self new)
		changeClass: aClass;
		selector: aSymbol;
		yourself
! !

!RemoveMethodChange methodsFor:'comparing'!

= aRemoveMethodChange 
	super = aRemoveMethodChange ifFalse: [^false].
	^selector = aRemoveMethodChange selector
!

hash
	^selector hash
! !

!RemoveMethodChange methodsFor:'converting'!

asUndoOperation
    ^ AddMethodChange compile:(self methodSourceFor: selector) in:self changeClass

    "Modified: / 10-10-2017 / 17:40:02 / cg"
! !

!RemoveMethodChange methodsFor:'initialization & release'!

selector: aSymbol 
	selector := aSymbol
! !

!RemoveMethodChange methodsFor:'printing'!

changeString
        ^'Remove <1s> from <2s>' expandMacrosWith: selector allBold
                with: self displayClassName
!

printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeSelector: ';
		nextPutAll: selector;
		nextPut: $!!
! !

!RemoveMethodChange methodsFor:'private'!

primitiveExecute
	^self changeClass removeSelector: selector
!

selector
	^selector
! !

!RemoveMethodChange methodsFor:'testing'!

isRemoveMethodChange
    ^ true
! !

!RemoveMethodChange class methodsFor:'documentation'!

version
    ^ '$Header$'
! !

