"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

"{ NameSpace: Smalltalk }"

BrowserEnvironment subclass:#BrowserEnvironmentWrapper
	instanceVariableNames:'environment'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!


!BrowserEnvironmentWrapper class methodsFor:'instance creation'!

new
	^self onEnvironment: BrowserEnvironment new
!

onEnvironment: anEnvironment 
	^(self basicNew)
		initialize;
		onEnvironment: anEnvironment;
		yourself
! !

!BrowserEnvironmentWrapper class methodsFor:'queries'!

isAbstract
    ^ self == BrowserEnvironmentWrapper
! !

!BrowserEnvironmentWrapper methodsFor:'accessing'!

selectionIntervalFor: aString 
	| interval |
	interval := super selectionIntervalFor: aString.
	^interval notNil 
		ifTrue: [interval]
		ifFalse: [environment selectionIntervalFor: aString]
! !

!BrowserEnvironmentWrapper methodsFor:'initialize-release'!

onEnvironment: anEnvironment
	environment := anEnvironment
! !

!BrowserEnvironmentWrapper methodsFor:'printing & storing'!

storeOn: aStream 
	aStream
		nextPutAll: '(';
		nextPutAll: self class name;
		nextPutAll: ' onEnvironment: '.
	environment storeOn: aStream.
	aStream nextPut: $)
! !

!BrowserEnvironmentWrapper methodsFor:'private'!

environment
	^environment
! !

!BrowserEnvironmentWrapper methodsFor:'testing'!

includesCategory: aCategory
	^environment includesCategory: aCategory
!

includesClass: aClass
	^environment includesClass: aClass
!

includesProtocol: aProtocol in: aClass
	^(self includesClass: aClass)
		and: [environment includesProtocol: aProtocol in: aClass]
!

includesSelector: aSelector in: aClass
	^(self includesClass: aClass)
		and: [environment includesSelector: aSelector in: aClass]
!

isEmpty
	self classesDo: [:each | ^false].
	^true
!

isSystem
	^false
! !

!BrowserEnvironmentWrapper class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

