"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

"{ NameSpace: Smalltalk }"

BrowserEnvironment subclass:#LimitedEnvironment
	instanceVariableNames:'environment'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!


!LimitedEnvironment class methodsFor:'instance creation'!

new
	^self onEnvironment: BrowserEnvironment new
!

onEnvironment: anEnvironment
	^(self basicNew) initialize; onEnvironment: anEnvironment; yourself
! !

!LimitedEnvironment methodsFor:'accessing'!

whichCategoryIncludes: aClassName
	^environment whichCategoryIncludes: aClassName
! !

!LimitedEnvironment methodsFor:'accessing-classes'!

classesDo: aBlock
    cachedClasses notNil ifTrue:[
        cachedClasses do:aBlock
    ] ifFalse:[ 
        self classNames
                do:
                        [:each |
                        | class |
                        class := self at: each ifAbsent: [nil].
                        class notNil
                                ifTrue:
                                        [(self includesClass: class)
                                                ifTrue: [aBlock value: class].
                                        (self includesClass: class class)
                                                ifTrue: [aBlock value: class class]]]
    ]
! !

!LimitedEnvironment methodsFor:'initialize-release'!

onEnvironment: anEnvironment
	environment := anEnvironment
! !

!LimitedEnvironment methodsFor:'testing'!

includesCategory: aCategory
	^environment includesCategory: aCategory
!

includesClass: aClass
	^environment includesClass: aClass
!

includesProtocol: aProtocol in: aClass
	^(self includesClass: aClass)
		and: [environment includesProtocol: aProtocol in: aClass]
!

includesSelector: aSelector in: aClass
	^(self includesClass: aClass)
		and: [environment includesSelector: aSelector in: aClass]
!

isSystem
	^false
! !

!LimitedEnvironment class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

