"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

"{ NameSpace: Smalltalk }"

RestrictedEnvironment subclass:#MultiEnvironment
	instanceVariableNames:'environmentDictionaries'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!


!MultiEnvironment methodsFor:'accessing'!

environments
	^environmentDictionaries keys
!

navigatorClass
	^MultiNavigator
!

problemCount
	^environmentDictionaries size
!

selectEnvironment: aValue 
	environment := environmentDictionaries at: aValue
				ifAbsent: [SelectorEnvironment new]
! !

!MultiEnvironment methodsFor:'adding'!

addClass: aClass into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		addClass: aClass
!

addClass: aClass selector: aSymbol into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		addClass: aClass
		selector: aSymbol
! !

!MultiEnvironment methodsFor:'initialize-release'!

initialize
	super initialize.
	environmentDictionaries := Dictionary new.
	environment := SelectorEnvironment new
! !

!MultiEnvironment methodsFor:'removing'!

removeClass: aClass into: aValue 
	(environmentDictionaries at: aValue ifAbsent: [SelectorEnvironment new]) 
		removeClass: aClass
!

removeClass: aClass selector: aSelector into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		removeClass: aClass
		selector: aSelector
! !

!MultiEnvironment methodsFor:'testing'!

isEmpty
	^environmentDictionaries isEmpty
! !

!MultiEnvironment class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

