"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

"{ NameSpace: Smalltalk }"

RBAbstractClass subclass:#RBMetaclass
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Model'
!

RBMetaclass comment:'RBMetaclass represents a Metaclass.
'
!


!RBMetaclass class methodsFor:'instance creation'!

existingNamed: aSymbol 
	^(self named: aSymbol)
		realName: aSymbol;
		yourself
!

named: aSymbol 
	^(self new)
		name: aSymbol;
		yourself
! !

!RBMetaclass methodsFor:'accessing'!

allClassVariableNames
	^self nonMetaclass allClassVariableNames
!

allPoolDictionaryNames
	^self nonMetaclass allPoolDictionaryNames
!

metaclass
	^self
!

name
    "/ cg: actually, this returns the wrong name 
    "/ (the name of the non-meta, without ' class' suffix).
    "/ I was tempted to change that, but then, a lot of other stuff inside
    "/ the RB framework fails.
    "/ Be prepared

    ^ super name
! !

!RBMetaclass methodsFor:'initialize-release'!

realName: aSymbol 
	self realClass: (Smalltalk at: aSymbol) class
! !

!RBMetaclass methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' class'
! !

!RBMetaclass methodsFor:'printing & storing'!

storeOn: aStream 
	super storeOn: aStream.
	aStream nextPutAll: ' class'
! !

!RBMetaclass methodsFor:'testing'!

directlyDefinesClassVariable: aString 
	^self nonMetaclass directlyDefinesClassVariable: aString
!

directlyDefinesPoolDictionary: aString 
	^self nonMetaclass directlyDefinesPoolDictionary: aString
!

isMeta
	^true
! !

!RBMetaclass class methodsFor:'documentation'!

version
    ^ '$Header$'
! !

