"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

"{ NameSpace: Smalltalk }"

SelectorEnvironment subclass:#SelectorEnvironmentWithInheritedMethods
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!

!SelectorEnvironmentWithInheritedMethods class methodsFor:'documentation'!

documentation
"
    a normal selector environment contains class-selector pairs for existing
    methods; the methodsInto:aCollection message will retrieve the implementations
    in the corresponding class (and not add anything, if not implemented in that class).

    This subclass will present the inherited method instead.
    Its only use is when searching for unimplemented/to-be-redefined methods,
    for which the class is presented, where methods are missing, but when clicking
    on a selector, the inherited method is shown.

    (see the SmallLint result for RBSubclassResponsibilityNotReimplementedRule 
    as an example)
"

    "Created: / 10-02-2017 / 13:32:32 / cg"
! !

!SelectorEnvironmentWithInheritedMethods methodsFor:'accessing'!

addMethodsFrom:class selectors:selectorSet into:aCollection
    "this enumerates the implementor, which may be in some superclass"
    
    selectorSet do:[:selector |
        |method|

        method := class lookupMethodFor:selector.
        method notNil ifTrue:[
            aCollection add:method.
        ].
    ]

    "Created: / 10-02-2017 / 13:16:53 / cg"
! !

!SelectorEnvironmentWithInheritedMethods class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

