"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

Annotation subclass:#LintRuleIgnoreAnnotation
	instanceVariableNames:'rule rationale author'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint'
!

!LintRuleIgnoreAnnotation class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!LintRuleIgnoreAnnotation class methodsFor:'instance creation'!

rule:rule rationale:rationale author:author
    ^ self new rule:rule rationale:rationale author:author

    "Created: / 29-07-2018 / 14:53:23 / Claus Gittinger"
! !

!LintRuleIgnoreAnnotation class methodsFor:'accessing'!

key
    ^#ignore:rationale:author:

    "Created: / 16-07-2017 / 13:35:55 / cg"
! !

!LintRuleIgnoreAnnotation methodsFor:'accessing'!

author
    ^ author
!

author:aString
    author := aString.

    "Modified (format): / 29-07-2018 / 14:53:32 / Claus Gittinger"
!

key

    ^ self class key

    "Created: / 24-08-2010 / 20:35:50 / Jan Vrany"
    "Modified: / 16-07-2017 / 13:36:04 / cg"
!

rationale
    ^ rationale
!

rationale:aString
    rationale := aString.

    "Modified (format): / 29-07-2018 / 14:53:38 / Claus Gittinger"
!

rule
    ^ rule
!

rule:aLintRule
    rule := aLintRule.

    "Modified (format): / 29-07-2018 / 14:53:46 / Claus Gittinger"
!

rule:ruleArg rationale:rationaleArg author:authorArg 
    rule := ruleArg.
    rationale := rationaleArg.
    author := authorArg.
!

storeOn:aStream

    aStream nextPutAll: '(Annotation ignore: '.
    self rule storeOn: aStream.
    aStream nextPutAll: ' rationale: '.
    self rationale storeOn: aStream.
    aStream nextPutAll: ' author: '.
    self author storeOn: aStream.
    aStream nextPut: $)

    "Created: / 24-08-2010 / 20:39:45 / Jan Vrany"
! !

!LintRuleIgnoreAnnotation class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

