"
 Copyright (C) 2018 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBAbstractClassRefersToSubclassRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBAbstractClassRefersToSubclassRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2018 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBAbstractClassRefersToSubclassRule class methodsFor:'accessing'!

tagsBasic
    ^#( dogmatic )

    "Created: / 09-10-2018 / 13:44:05 / Claus Gittinger"
! !

!RBAbstractClassRefersToSubclassRule methodsFor:'accessing'!

group
    ^ 'Possible Bugs'

    "Modified (format): / 09-10-2018 / 13:02:52 / Claus Gittinger"
!

name
        ^ 'Abstract class refers to a subclass'

    "Modified: / 09-10-2018 / 13:03:20 / Claus Gittinger"
!

rationale
        ^ 'Checks for abstract classes which refer to a subclass (instead of "self class"). 
Abstract classes should not know about any concrete subclass explicitly.'

    "Modified: / 12-02-2012 / 09:23:48 / cg"
    "Modified: / 09-10-2018 / 13:04:16 / Claus Gittinger"
! !

!RBAbstractClassRefersToSubclassRule methodsFor:'running'!

checkClass:aContext 
    |cls sels className searchBadRefs|

    searchBadRefs :=
        [:sel :mthd |
            |any|

            any := mthd usedGlobals 
                        contains:[:nm |
                            |refdClass|

                            refdClass := (Smalltalk classNamed:nm).
                            refdClass isNil ifTrue:[
                                cls nameSpace notNil ifTrue:[
                                    refdClass := (cls nameSpace classNamed:nm).
                                ].    
                            ].    
                            refdClass isBehavior and:[ refdClass isSubclassOf:cls ]
                        ].    
            any ifTrue:[             
                self addClass:(mthd mclass) selector:sel to:result                    
            ].
        ].
    
    cls := aContext selectedClass theNonMetaclass.
    cls isAbstract ifTrue:[
        cls methodDictionary keysAndValuesDo:searchBadRefs.
        cls class methodDictionary keysAndValuesDo:searchBadRefs.
    ].
"/    sels notEmpty ifTrue:[
"/        result addSearchString:className
"/    ]

    "Modified: / 09-10-2018 / 13:41:17 / Claus Gittinger"
! !

!RBAbstractClassRefersToSubclassRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

