"
 Copyright (C) 2017 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBBadIsNilCheckRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!

!RBBadIsNilCheckRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2017 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBBadIsNilCheckRule methodsFor:'accessing'!

group
        ^ 'Bugs'

    "Modified: / 25-08-2017 / 10:00:29 / cg"
!

name
        ^ 'Bad isNil/notNil check after comparison'

    "Modified: / 25-08-2017 / 09:59:25 / cg"
!

rationale
        ^ 'Checks for code like
<CODE><PRE>
    ( expr1 == expr2 ) isNil
</PRE></CODE>
which might be found after a wrong copy-paste editing operation,
or if an assignment was mistyped as "=" or "==".
<P>
In any case, this is a bug, as the result from isNil will always be false,
and the result from notNil will always be true.
'

    "Modified: / 25-08-2017 / 10:01:09 / cg"
! !

!RBBadIsNilCheckRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                    ' (`@expr1 == `@expr2) isNil ' 
                    ' (`@expr1 == `@expr2) notNil ' 
                    ' (`@expr1 ~~ `@expr2) isNil ' 
                    ' (`@expr1 ~~ `@expr2) notNil ' 

                    ' (`@expr1 = `@expr2) isNil ' 
                    ' (`@expr1 = `@expr2) notNil ' 
                    ' (`@expr1 ~= `@expr2) isNil ' 
                    ' (`@expr1 ~= `@expr2) notNil ' 

                    ' (`@expr1 > `@expr2) isNil ' 
                    ' (`@expr1 > `@expr2) notNil ' 
                    ' (`@expr1 < `@expr2) isNil ' 
                    ' (`@expr1 < `@expr2) notNil ' 
                    ' (`@expr1 >= `@expr2) isNil ' 
                    ' (`@expr1 >= `@expr2) notNil ' 
                    ' (`@expr1 <= `@expr2) isNil ' 
                    ' (`@expr1 <= `@expr2) notNil ' 
                )
                do: [ :node :answer | node ]

    "Modified: / 25-08-2017 / 09:57:04 / cg"
! !

!RBBadIsNilCheckRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

