"{ Encoding: utf8 }"

"
 Copyright (C) 2018 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBBadVariableNameRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBBadVariableNameRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2018 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBBadVariableNameRule methodsFor:'accessing'!

group
        ^ 'Intention Revealing'
!

name
        ^ 'Bad temporary variables'
!

rationale
    ^ self 
        appendSearchStringsResultAs:'Variables:' 
        toRationale: 
'Temporary and argument variable names should be named properly.'

    "Modified (format): / 10-02-2017 / 14:44:19 / cg"
! !

!RBBadVariableNameRule methodsFor:'running'!

badNames
    "strings considered bad (heuristic)"

    ^ #(
        'something'
        'sth'
        'foo' 'bar' 'baz'
    )
!

checkMethod: aContext 
    |source badNames|

    "a quick rejector, to avoid many parses (because parsing is very slow)"
    "(if there is no vertical bar, there cannot be a temporary;
      if there is no colon, there can be no keyword or block arg."
    source := aContext sourceCode.
    ( source includesAny:'|:' ) ifFalse:[^ self].

    badNames := self badNames.

    (aContext selector == #'update:with:from:') ifTrue:[
        badNames := badNames copyWithout:'something'.
    ].
    aContext parseTree allDefinedVariables do:[ :eachVarName | 
        "/ cg: check for isUpper instead of isLower-not, because underline is OK in ST/X
        (badNames contains:[:someBadName | eachVarName sameAs:someBadName]) ifTrue:[ 
            result 
                addClass: aContext selectedClass
                selector: aContext selector.
            result addSearchString: eachVarName 
        ] 
    ]

    "Modified: / 28-05-2019 / 08:15:22 / Claus Gittinger"
    "Modified: / 08-05-2020 / 11:11:18 / cg"
! !

!RBBadVariableNameRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

