"{ Encoding: utf8 }"

"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBConsistencyCheck2Rule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBConsistencyCheck2Rule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBConsistencyCheck2Rule methodsFor:'accessing'!

group
        ^ 'Intention Revealing'
!

name
       "/ ^ 'Uses "at: 1" or "at: size" instead of "first" or "last"'
        ^ 'Uses "x at:(x size)" instead of "x last"'

    "Modified: / 06-03-2012 / 18:42:58 / cg"
!

rationale
        ^ 'Checks for indexed access instead of "<CODE>last</CODE>".
<P>
Notice, that some basic classes use "<CODE>at:</CODE>" for performance reasons,
(to avoid an extra message send) so the outcome of this rule should be checked,
especially for the classes in the collection and stream hierarchies.'.

"/        ^ 'Checks for indexed access instead of "<CODE>first</CODE>" or "<CODE>last</CODE>".
"/Especially the reference to the last object may be easier to understand 
"/if written as "<CODE>coll last</CODE>".
"/<P>
"/It may be argued, if this rule is misleading for "<CODE>first</CODE>".
"/<P>
"/Notice, that many basic classes use "<CODE>at:</CODE>" for performance reasons
"/(to avoid an extra message send) so the outcome of this rule should be checked,
"/especially for the classes in the collection and stream hierarchies.'.
! !

!RBConsistencyCheck2Rule methodsFor:'checking'!

checkMethod: aContext
    "skip the implemntations of first and last"
    
    |selector cls|

    "/ don't do it in tests (might just be the code to verify last)
    cls := aContext selectedClass.
    cls := cls realClass.
    cls isNil ifTrue:[^ self].
    cls isTestCaseLike ifTrue:[^ self].

    selector := aContext selector.
    selector == #first ifTrue:[^ self].
    selector == #last ifTrue:[^ self].

    super checkMethod:aContext 
! !

!RBConsistencyCheck2Rule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        "/ '`@collection at: 1'
                        '`@collection at: `@collection size' )
                do: [ :node :answer | node ]
! !

!RBConsistencyCheck2Rule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

