"{ Encoding: utf8 }"

"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBDuplicatedCodeRule subclass:#RBDuplicatedTokenRule
	instanceVariableNames:'index'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Experimental Rules'
!


!RBDuplicatedTokenRule methodsFor:'accessing'!

name
	^ super name , ' (token)'
! !

!RBDuplicatedTokenRule methodsFor:'initialization'!

initialize
	super initialize.
	index := OrderedCollection new
! !

!RBDuplicatedTokenRule methodsFor:'private'!

minimalSize
	^ 10
!

scanTokens: aContext
	| tokens scanner |
	tokens := OrderedCollection new.
	scanner := RBScanner
		on: aContext sourceCode asString readStream
		errorBlock: [ :s :p | ^ tokens ].
	[ scanner atEnd ] 
		whileFalse: [ tokens addLast: scanner next value ].
	^ tokens asArray
! !

!RBDuplicatedTokenRule methodsFor:'running'!

checkMethod: aContext
    |checkedMethod tokens numTokens substring |

    checkedMethod := aContext compiledMethod.

    tokens := self scanTokens: aContext.
    numTokens := tokens size.
    1 to:(numTokens - self minimalSize) do: [ :i |
        (i + self minimalSize) to:(numTokens) do: [ :j |
            substring := tokens copyFrom: i to: j.
            index do:[:assoc |
                |anotherMethod source |
                anotherMethod := assoc key.
                source := assoc value.
                (source indexOfSubCollection: substring startingAt: 1) == 0 ifFalse: [ 
                    self addDuplication:checkedMethod with:anotherMethod in:result 
                ] 
            ] 
        ] 
    ].
    index addLast:(checkedMethod -> tokens)
! !

!RBDuplicatedTokenRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

