"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBEquivalentSuperclassMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBEquivalentSuperclassMethodsRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
!

documentation
"
    this is a duplicate of RBCodeDuplication rule,
    which was independently developed at exept, and gives better results.
    Therefore, this rule is not used (tagged as obsolete)
"    
! !

!RBEquivalentSuperclassMethodsRule class methodsFor:'accessing'!

tagsBasic
    ^ #(obsolete)
! !

!RBEquivalentSuperclassMethodsRule methodsFor:'accessing'!

group
        ^ 'Unnecessary Code'
!

ignoredSelectors
        "These methods are often overridden for compatibility with other platforms."

        ^ #( new initialize )
!

name
	^ 'Methods equivalently defined in superclass'
!

rationale
        ^ 'Check for methods that are equivalent to their superclass methods. 
Such methods don''t add anything to the computation and can be removed 
since the superclass''s method will work just fine.'
!

severity
        ^ SeverityInformation
! !

!RBEquivalentSuperclassMethodsRule methodsFor:'running'!

checkMethod:aContext 
    |class selector superclass implClass supertree|

    class := aContext selectedClass.
    selector := aContext selector.
    superclass := class superclass.

    class superclass isNil ifTrue:[^ self].
    class isMeta ifTrue:[ 
        (#(documentation examples copyright) includes:selector) ifTrue:[^ self].
    ]. 

    implClass := superclass whichClassIncludesSelector:selector.
    implClass isNil ifTrue:[^ self].
    
    supertree := implClass parseTreeFor:selector.
    supertree isNil ifTrue:[^ self].    
    
    (supertree 
        equalTo:aContext parseTree
        exceptForVariables:supertree allDefinedVariables
    ) ifTrue:[
        self addClass:class selector:selector to:result
    ]
! !

!RBEquivalentSuperclassMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

