"
 Copyright (C) 2017 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBTransformationRule subclass:#RBExceptionRaiseCodeReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!

!RBExceptionRaiseCodeReplaceRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2017 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBExceptionRaiseCodeReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:56:58 / cg"
!

name
    ^ 'Simplify exception raising code'

    "Modified: / 09-08-2017 / 10:11:42 / cg"
!

rationale
    ^ 'Transform <code><pre>    (ExceptionClass new messageText:someText) raise</pre></code> 
and similar obfuscated and unreasonably complicated constructs by shorter code sequences,
such as <code><pre>    ExceptionClass raiseErrorString:someText</pre></code> 
'

    "Modified: / 09-08-2017 / 10:16:14 / cg"
! !

!RBExceptionRaiseCodeReplaceRule methodsFor:'initialization'!

initialize
    super initialize.
    self rewriteRule 
        replace:'(``@exClass new messageText:``@message) raise'        with:'``@exClass raiseErrorString:``@message';        
        replace:'(``@exClass new messageText:``@message) raiseRequest' with:'``@exClass raiseRequestErrorString:``@message';

        replace:'(``@exClass new) messageText:``@message; raise'        with:'``@exClass raiseErrorString:``@message';        
        replace:'(``@exClass new) messageText:``@message; raiseRequest' with:'``@exClass raiseRequestErrorString:``@message';

        replace:'(``@exClass new) messageText:``@message; parameter:``@param; raise'        with:'``@exClass raiseWith:``@param errorString:``@message';        
        replace:'(``@exClass new) messageText:``@message; parameter:``@param; raiseRequest' with:'``@exClass raiseRequestWith:``@param errorString:``@message';

        replace:'(``@exClass new) parameter:``@param; messageText:``@message; raise'        with:'``@exClass raiseWith:``@param errorString:``@message';        
        replace:'(``@exClass new) parameter:``@param; messageText:``@message; raiseRequest' with:'``@exClass raiseRequestWith:``@param errorString:``@message';

        replace:'(``@exClass newException messageText:``@message) raise'        with:'``@exClass raiseErrorString:``@message';        
        replace:'(``@exClass newException messageText:``@message) raiseRequest' with:'``@exClass raiseRequestErrorString:``@message';

        replace:'(``@exClass newException) messageText:``@message; raise'        with:'``@exClass raiseErrorString:``@message';        
        replace:'(``@exClass newException) messageText:``@message; raiseRequest' with:'``@exClass raiseRequestErrorString:``@message';

        replace:'(``@exClass newException) messageText:``@message; parameter:``@param; raise'        with:'``@exClass raiseWith:``@param errorString:``@message';        
        replace:'(``@exClass newException) messageText:``@message; parameter:``@param; raiseRequest' with:'``@exClass raiseRequestWith:``@param errorString:``@message';

        replace:'(``@exClass newException) parameter:``@param; messageText:``@message; raise'        with:'``@exClass raiseWith:``@param errorString:``@message';        
        replace:'(``@exClass newException) parameter:``@param; messageText:``@message; raiseRequest' with:'``@exClass raiseRequestWith:``@param errorString:``@message';
        yourself

    "Modified: / 09-08-2017 / 10:31:53 / cg"
! !

!RBExceptionRaiseCodeReplaceRule methodsFor:'running'!

shouldIgnoreClass: aClass selector: selector
    ^ super shouldIgnoreClass:aClass selector:selector.

    "Modified: / 09-08-2017 / 10:11:15 / cg"
! !

!RBExceptionRaiseCodeReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

