"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBMethodModifierFinalRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBMethodModifierFinalRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Overrides a final method'
!

rationale
	^ 'Checks that a methods marked with <modifier: #final> is never overridden.'
!

severity
	^ #error
! !

!RBMethodModifierFinalRule methodsFor:'running'!

checkMethod: aContext
    |cls selector current |

    cls := aContext selectedClass.
    selector := aContext selector.

    current := cls superclass.
    [ current notNil ] whileTrue: [
            | method |
            method := current methodDictionary at:selector ifAbsent:[nil].
            method notNil ifTrue:[
                | annotations |
                annotations := method perform: #annotations ifNotUnderstood: [nil].
                (annotations anySatisfy: [ :each | each keyword = #modifier: and: [ each arguments first = #final ] ])
                    ifTrue: [ 
                        result addClass:cls selector:selector.
                        ^ self.
                    ].
            ].
            current := current superclass ]

    "Modified: / 04-08-2011 / 19:37:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 07-02-2017 / 19:22:38 / cg"
! !

!RBMethodModifierFinalRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

