"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBMethodModifierOverrideRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBMethodModifierOverrideRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Missing super implementation'
!

rationale
	^ 'Checks that a methods marked with <modifier: #override> overrides an actual superclass method.'
!

severity
	^ #error
! !

!RBMethodModifierOverrideRule methodsFor:'running'!

checkMethod: aContext

    | annotations cls sel|

    annotations := aContext compiledMethod perform: #annotations ifNotUnderstood: [nil].
    annotations isNil ifTrue:[^self].

    (annotations anySatisfy: [ :each | each key = #modifier: and: [ each arguments first = #override ] ])
        ifFalse: [ ^ self ].
        
    cls := aContext selectedClass.
    (cls superclass isNil)
        ifTrue: [ ^ self ].
        
    sel := aContext selector.
    (cls superclass whichClassIncludesSelector: sel) isNil
        ifTrue: [ result addClass: cls selector: sel ]

    "Modified: / 04-08-2011 / 21:28:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (format): / 26-02-2017 / 14:23:53 / cg"
! !

!RBMethodModifierOverrideRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

