"{ Encoding: utf8 }"

"
 Copyright (C) 2017 Claus Gittinger
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBMissingDocumentationRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!

!RBMissingDocumentationRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2017 Claus Gittinger
"
! !

!RBMissingDocumentationRule class methodsFor:'accessing'!

tagsBasic
    "Return an array of tags (symbols) of given rule. Any rule may
     arbitrary number of tags. Tag values are not predefined/fixed.
     See class documentation for list of common tags"

    ^ #( 
        stx         "/ code is Smalltalk/X specific
        excludedForExpecco
    )
! !

!RBMissingDocumentationRule methodsFor:'accessing'!

group
        ^ 'Miscellaneous'

    "Modified: / 29-11-2017 / 12:04:33 / cg"
!

name
        ^ 'Class without documentation'

    "Modified: / 29-11-2017 / 12:04:45 / cg"
!

rationale
        ^ 'Checks if a class has a documentation method.'

    "Modified: / 29-11-2017 / 12:05:02 / cg"
!

resultClass
    "I will return the set of failing classes"

    ^ ClassEnvironment

    "Created: / 29-11-2017 / 12:13:18 / cg"
! !

!RBMissingDocumentationRule methodsFor:'running'!

checkClass: aContext 
    | selectedClass doc|

    selectedClass := aContext selectedClass.
    selectedClass isMeta ifFalse:[
        doc := selectedClass commentOrDocumentationString.
        (doc isEmptyOrNil 
        or:[ (doc includesString:'to be added' caseSensitive:false)]) ifTrue:[
            result addClass:selectedClass
        ].    
    ].

    "Modified: / 29-11-2017 / 12:14:00 / cg"
! !

!RBMissingDocumentationRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

