"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBMissingTranslationsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!

!RBMissingTranslationsRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBMissingTranslationsRule methodsFor:'accessing'!

group
    ^ 'Bugs - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:57:04 / cg"
!

name
        ^ 'Missing translations in dialogs'

    "Modified: / 07-04-2012 / 13:11:32 / cg"
!

rationale
        ^ 'Literal strings shown to users in dialogs 
(such as "<code>Dialog request:''aMessage''</code>") should be translated 
to a national language using the resource mechanism. 
eg. by rewriting it to "<code>Dialog request:(resources string:''aMessage'')</code>".
<P>
This check covers only the most common and obvious such occurrences. 
If in doubt, check string constants. 
Remember: Lint is not a replacement for a visual GUI inspection done by a human.
<P>
This rule is ignored in TestCase classes.'

    "Modified: / 06-03-2012 / 18:38:23 / cg"
! !

!RBMissingTranslationsRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher
                matchesAnyOf: #(
                        '`@dialog request: `#label'
                        '`@dialog request: `#label initialAnswer: `@expr1'
                        '`@dialog request: `#label initialAnswer: `@expr1 list: `@expr2'
                        '`@dialog request: `#label initialAnswer: `@expr1 onCancel: `@expr2'
                        '`@dialog request: `#label okLabel: `@expr1 title: `@expr2'
                        '`@dialog request: `#label list: `@expr1'
                        '`@dialog request: `#label list: `@expr1 initialAnswer: `@expr2'
                        '`@dialog requestFileName: `#label'
                        '`@dialog requestFileName: `#label default: `@expr1'
                        '`@dialog requestFileName: `#label default: `@expr1 fromDirectory: `@expr2 '
                        '`@dialog requestFileName: `#label pattern: `@expr1'
                        '`@dialog requestDirectoryName: `#label'
                        '`@dialog requestDirectoryName: `#label default: `@expr1'
                        '`@dialog confirm: `#label'
                        '`@dialog confirm: `#label default: `@expr1'
                        '`@dialog confirm: `#label initialAnswer: `@expr1'
                        '`@dialog confirm: `#label title: `@expr1'
                        '`@dialog confirm: `#label withCancel: `@expr1'
                        '`@dialog confirmWithCancel: `#label'
                        '`@dialog confirmWithCancel: `#label default: `@expr1'
                        '`@dialog confirmWithCancel: `#label initialAnswer: `@expr1'
                        '`@dialog information: `{:node| node isLiteral and:[node value notNil]}'
                        '`@dialog information: `#label title: `@expr1'
                        '`@dialog warn: `#label'
                        '`@dialog warn: `#label title: `@expr1'
                        'MenuItem label: `#label itemValue: `@expr1 enabled: `@expr2'
                        'MenuItem label: `#label itemValue: `@expr1 argument: `@expr2'
                        'MenuItem label: `#label itemValue: `@expr1 translateLabel: `@expr2'
                        'MenuItem label: `#label itemValue: `@expr1'
                        'MenuItem label: `#label submenuChannel: `@expr1'
                        'MenuItem label: `#label'
                        'MenuItem label: `#label argument: `@expr1'
                        'MenuItem label: `#label choice: `@expr1 choiceValue: `@expr2'
"/                        '`@menu add: `#label action: `@expr1'
"/                        '`@menu add: `#label selector: `@expr1 arguments: `@stuff'
"/                        '`@menu add: `#label subMenu: `@stuff target: `@targ selector: `#sel argumentList: `@args'
"/                        '`@menu add: `#label subMenu: `@stuff'
"/                        '`@menu add: `#label target: `@targ action: `#sel'
"/                        '`@menu add: `#label target: `@targ selector `#sel argument: `@arg'
"/                        '`@menu add: `#label target: `@targ selector `#sel arguments: `@arg'
"/                        '`@menu add: `#label target: `@targ selector `#sel'
"/                        '`@menu addList: `{ :n | n isLiteral and: [ n value isArray and: [ n value anySatisfy: [ :row | (row isKindOf: Array) and: [ row first isLiteral ] ] ] ] }'
"/                        '`@menu addTitle: `#label updatingSelector: `#sel updateTarget: `@targ'
"/                        '`@menu addTitle: `#label'
"/                        '`@menu addWithLabel: `#label enablement: `#esel action: `#sel'
"/                        '`@menu addWithLabel: `#label enablementSelector: `#esel target: `@targ selector: `#sel argumentList: `@args'
"/                        '`@menu balloonTextForLastItem: `#label'
"/                        '`@menu labels: `#lit lines: `@lines selections: `@sels'
"/                        '`@menu title: `#title' 
                )
                do: [ :node :answer | node ]

    "Modified: / 29-11-2017 / 12:25:11 / cg"
! !

!RBMissingTranslationsRule methodsFor:'running'!

shouldIgnoreClass: aClass selector: selector
    aClass isTestCaseLike ifTrue:[^ true].
    ^ super shouldIgnoreClass:aClass selector:selector.
! !

!RBMissingTranslationsRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

