"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBMultiplePeriodsTerminatingStatementRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBMultiplePeriodsTerminatingStatementRule class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        cg

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!RBMultiplePeriodsTerminatingStatementRule methodsFor:'accessing'!

basicCheck: aMethod
    aMethod parseTree nodesDo: [ :each |
        (each isSequence and: [ each periods size > each statements size ])
            ifTrue: [ ^ true ] 
    ].
    ^ false

    "Created: / 16-07-2017 / 12:28:12 / cg"
!

checkMethod: aMethod
    (self basicCheck: aMethod) ifTrue: [ 
        result addMethod: aMethod 
    ]

    "Created: / 16-07-2017 / 12:26:58 / cg"
!

group
    ^ 'Potential Bugs'..

    "Created: / 16-07-2017 / 12:26:01 / cg"
!

name
    ^ 'Multiple periods terminating the same statement'

    "Created: / 16-07-2017 / 12:25:42 / cg"
!

rationale
    ^ 'A rule to check for multiple periods terminating the same statement, 
which is unnecessary, probably unintentional, and can cause problems when porting to other platforms like GemStone,
and will definitly make problems when stc-compiling'

    "Created: / 16-07-2017 / 12:29:37 / cg"
! !

!RBMultiplePeriodsTerminatingStatementRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

