"{ Encoding: utf8 }"

"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBOverridesDeprecatedMethodRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBOverridesDeprecatedMethodRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBOverridesDeprecatedMethodRule methodsFor:'accessing'!

group
        ^ 'Potential Bugs'

    "Modified: / 13-07-2017 / 23:53:32 / cg"
!

name
        ^ 'Overrides a deprecated method'

    "Modified: / 13-07-2017 / 23:52:59 / cg"
!

rationale
    ^ 'The method overrided a deprecated method. 
This is a sign that an API has changed in an upstream project 
and most likely the method should override another one.'

    "Modified: / 13-07-2017 / 23:52:45 / cg"
!

severity
        ^ SeverityWarning

    "Modified: / 13-07-2017 / 23:51:38 / cg"
! !

!RBOverridesDeprecatedMethodRule methodsFor:'running'!

checkMethod:aContext
    |overriddenMethods method selector|

    method := aContext compiledMethod.
    method isObsolete ifTrue:[
        "an obsolete method may overwrite an obsolete method"    
        ^ self.
    ].

    overriddenMethods := OrderedCollection new.
    selector := aContext selector.
    
    method mclass allSuperclasses do: [ :class |
        |mthd|

        mthd := class compiledMethodAt:selector.
        mthd notNil ifTrue:[ overriddenMethods add: mthd ].
    ].
    
    (overriddenMethods anySatisfy:#isObsolete) ifTrue:[
        self 
            addClass: aContext selectedClass 
            selector: selector 
            to: result.
    ].

    "Created: / 13-07-2017 / 23:55:02 / cg"
    "Modified (format): / 29-11-2019 / 14:39:34 / Stefan Vogel"
! !

!RBOverridesDeprecatedMethodRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

