"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBPrecedenceRule2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBPrecedenceRule2 class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBPrecedenceRule2 methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
    ^ 'MIssing parentheses in conditional return'

    "Modified: / 20-06-2017 / 10:30:46 / cg"
    "Modified: / 13-03-2019 / 19:44:12 / Claus Gittinger"
!

rationale
        ^ 'Checks for possible errors due to missing parentheses in expressions like: 
<code><pre>    var := expr notNil ifTrue:[^ var]</pre></code>
was''n meant to be:
<code><pre>    (var := expr) notNil ifTrue:[^ var]</pre></code>
<P>
This is a common typing error.'

    "Modified: / 20-06-2017 / 10:37:10 / cg"
    "Modified: / 13-03-2019 / 19:36:59 / Claus Gittinger"
! !

!RBPrecedenceRule2 methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                            '`v := `@e notNil ifTrue:[^ `v ]'
                            '`v := `@e isNil ifFalse:[^ `v ]'
                            '`v := `@e ifTrue:[^ `v ]'
                            '`v := `@e ifFalse:[^ `v ]'
                )
                do: [ :node :answer | node ]

    "Modified: / 20-06-2017 / 10:28:27 / cg"
    "Modified: / 13-03-2019 / 19:44:32 / Claus Gittinger"
! !

!RBPrecedenceRule2 class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

