"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBQuestionableResourceArgumentRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBQuestionableResourceArgumentRule methodsFor:'accessing'!

group
    ^ 'Possible Bugs - Smalltalk/X'

    "Created: / 03-08-2017 / 14:26:56 / cg"
    "Modified: / 29-11-2017 / 12:44:23 / cg"
!

name
    ^ 'Checks for questionable arguments.'

    "Created: / 03-08-2017 / 14:27:21 / cg"
    "Modified: / 29-11-2017 / 11:56:19 / cg"
!

rationale
        ^ 'Questionable argument.
<P>
For some wellknown messages, the expected argument types are known
and can be checked statically.
'

    "Created: / 03-08-2017 / 14:30:33 / cg"
    "Modified: / 29-11-2017 / 12:41:11 / cg"
!

severity
    ^ SeverityWarning

    "Created: / 03-08-2017 / 14:31:12 / cg"
    "Modified: / 29-11-2017 / 11:57:13 / cg"
! !

!RBQuestionableResourceArgumentRule methodsFor:'initialization'!

initialize
    super initialize.

    self matcher 
        matchesAnyOf:#( 
            'resources string: `#lit '
            '`@expr resources string: `#lit '
            '`@expr classResources string: `#lit '
        )
        do:[:node :answer |
            |rslt arg|

            arg := node arguments first.
            arg value isString ifFalse:[
                rslt := node.
            ].    
            rslt ? answer
        ];
        
        matchesAnyOf:#( 
            'resources array: `#lit '
            '`@expr resources array: `#lit '
            '`@expr classResources array: `#lit '
        )
        do:[:node :answer |
            |rslt arg|

            arg := node arguments first.
            (arg value isArray
            and:[ (arg value conform:[:el | el isString]) ]) ifFalse:[
                rslt := node.
            ].    
            rslt ? answer
        ]

    "Created: / 29-11-2017 / 12:36:08 / cg"
! !

!RBQuestionableResourceArgumentRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

