"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBRefersToClassRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBRefersToClassRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBRefersToClassRule methodsFor:'accessing'!

group
    "/ result class == Array ifTrue:[^ 'xxx'].
        ^ 'Miscellaneous'
!

name
	^ 'Refers to class name instead of "self class"'
!

rationale
        ^ 'Checks for classes that have their class name directly in the source instead of "self class". 
The "self class" variant allows you to create subclasses without a need to redefine that method.
<P>Be aware, that sometimes an explicit check is ok and actually needed, 
for example, to detect abstract class uses.
<p>See implementations of #isAbstract, and #isBuiltInClass 
which only return true for the class itself, but not for subclasses.
<br>These two method implementations are skipped in this check.'

    "Modified: / 12-02-2012 / 09:23:48 / cg"
    "Modified: / 09-10-2018 / 13:01:35 / Claus Gittinger"
! !

!RBRefersToClassRule methodsFor:'running'!

checkClass:aContext 
    |cls sels className|

    cls := aContext selectedClass.
    className := cls theNonMetaclass name.

    sels := cls whichSelectorsReferTo:(Smalltalk associationAt:className).
    "/ add them, but filter some.
    sels do:[:eachSelector | 
        "/ cg: allow isAbstract and isBuiltInClass
        (cls isMeta and:[eachSelector == #isAbstract or:[eachSelector == #isBuiltInClass]]) ifTrue:[
            "/ skipped
        ] ifFalse:[    
            (eachSelector == #classNamesAndAttributes 
                and:[ cls isMeta 
                and:[ cls theNonMetaclass isProjectDefinition ]]
            ) ifTrue:[
                "/ skipped
            ] ifFalse:[    
                self 
                    addClass:cls
                    selector:eachSelector
                    to:result
            ].
        ].
    ].
    sels notEmpty ifTrue:[
        result addSearchString:className
    ]

    "Modified (format): / 09-10-2018 / 13:00:32 / Claus Gittinger"
! !

!RBRefersToClassRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

