"
 Copyright (C) 2020 Claus Gittinger
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBTransformationRule subclass:#RBStreamCRRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!

!RBStreamCRRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2020 Claus Gittinger
"
! !

!RBStreamCRRule class methodsFor:'queries'!

tagsBasic
    "this rule is broken; 
     it generates duplicate comments"

    ^#( "#broken" )
! !

!RBStreamCRRule methodsFor:'accessing'!

group
	^ 'Transformations'
!

name
    ^ '"nextPutAll + cr" -> "nextPutLine"'
!

rationale
    ^ 'Code like: 
<code><pre>    aStream nextPutAll:aString ; cr</pre></code> 
can be rewritten to <code><pre>    aStream nextPutLine:aString</pre></code>
<p>This is easier to read and also generates smaller binary code.'
!

severity
        ^ SeverityInformation
! !

!RBStreamCRRule methodsFor:'initialization'!

initialize
    super initialize.

    #FIXME.
    self rewriteRule
        replace: ' `@stream nextPutAll: `arg ; cr'
        with: ' `@stream nextPutLine: `arg ';

        yourself
! !

!RBStreamCRRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

