"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBToDoCollectRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBToDoCollectRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBToDoCollectRule methodsFor:'accessing'!

group
        ^ 'Intention Revealing'
!

name
        ^ 'Use "to:do:" instead of "collect:"'

    "Modified: / 02-03-2012 / 01:37:44 / cg"
!

rationale
        ^ 'Checks for uses of "<code>to:do:</code>" 
when a "<code>collect:</code>" should be used to construct a collection of results.'

    "Created: / 02-03-2012 / 01:38:21 / cg"
! !

!RBToDoCollectRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '| `@temps1 |
                            `@.Stmts1.
                            `collection := Array new: `@size.
                            `@.Stmts2.
                            1 to: `@size do: [:`i | 
                                    | `@Btemps2 | 
                                    `@.BStmts1. 
                                    `collection at: `i put: `@obj.
                                    `@.BStmts2].
                            `@.Stmts3
                        '

                        '| `@temps1 |
                            `@.Stmts1.
                            `collection := Array new: `@size.
                            `@.Stmts2.
                            1 to: `collection size do: [:`i | 
                                    | `@Btemps2 | 
                                    `@.BStmts1. 
                                    `collection at: `i put: `@obj.
                                    `@.BStmts2].
                            `@.Stmts3
                        ' 
                )
                do: [ :node :answer :owner :context |
                    |argNode accessNode loopStats loopBlock loopNode|
                    
                    "/ notice: the above matches the whole method,
                    "/ but we should only highlight/mark the actual loop code...
                    argNode := context at:(RBPatternVariableNode named:'`@obj') ifAbsent:[nil].
                    argNode notNil ifTrue:[
                        accessNode := argNode parent.
                        accessNode notNil ifTrue:[
                            loopStats := accessNode parent.
                            loopStats notNil ifTrue:[
                                loopBlock := loopStats parent.
                                loopBlock notNil ifTrue:[
                                    loopNode := loopBlock parent.
                                ]
                            ]
                        ]
                    ].
                    loopNode ? node 
                ]

    "Modified: / 25-08-2017 / 09:29:04 / cg"
! !

!RBToDoCollectRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

