"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBUnnecessaryDoubleNilCheckRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBUnnecessaryDoubleNilCheckRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBUnnecessaryDoubleNilCheckRule methodsFor:'accessing'!

group
        ^ 'Unnecessary Code'
!

name
        ^ 'Unnecessary double nil-check of a variable'

    "Modified: / 26-06-2019 / 12:23:40 / Claus Gittinger"
!

rationale
    ^ 'Check for unnecessary nil-checks within if-branches'

    "Created: / 01-03-2012 / 11:37:16 / cg"
    "Modified: / 26-06-2019 / 12:24:03 / Claus Gittinger"
!

severity
        ^ SeverityInformation
! !

!RBUnnecessaryDoubleNilCheckRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf:#(
                     '`v isNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v notNil 
                                ifTrue:`@ifBlock2
                                ifFalse:`@ifBlock3 ]'
                     '`v isNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v notNil 
                                ifTrue:`@ifBlock2 ]'
                                
                     '`v isNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v isNil 
                                ifTrue:`@ifBlock2
                                ifFalse:`@ifBlock3 ]'
                     '`v isNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v isNil 
                                ifTrue:`@ifBlock2 ]'
                                
                     '`v notNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v isNil 
                                ifTrue:`@ifBlock2
                                ifFalse:`@ifBlock3 ]'
                     '`v notNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v isNil 
                                ifTrue:`@ifBlock2 ]'
                                
                     '`v notNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v notNil 
                                ifTrue:`@ifBlock2
                                ifFalse:`@ifBlock3 ]'
                     '`v notNil 
                        ifTrue:`@ifBlock1 
                        ifFalse:[ 
                            `v notNil 
                                ifTrue:`@ifBlock2 ]'
                )
                do: [ :node :answer | node ]

    "Modified: / 26-06-2019 / 12:28:05 / Claus Gittinger"
! !

!RBUnnecessaryDoubleNilCheckRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

