"
 Copyright (C) 2020 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBTransformationRule subclass:#RBUnneededAsLowercaseRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!

!RBUnneededAsLowercaseRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2020 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBUnneededAsLowercaseRule methodsFor:'accessing'!

group
        ^ 'Unnecessary Code'
!

name
        ^ 'Avoid unneeded asLowercase/asUppercase conversions in string compares'
!

rationale
        ^ 'Eliminates unneeded case conversion in string compares.
<br>For example, 
<CODE><PRE>
    arg asLowercase startWith:''string-constant''
</PRE><?/ODE>
is better written as 
<CODE><PRE>
    arg startWith:''string-constant'' caseSensitive:false
</PRE><?/ODE>
'
! !

!RBUnneededAsLowercaseRule methodsFor:'initialization'!

initialize
        super initialize.
        self rewriteRule
                replace: ' `@expr1 asLowercase startsWith: `@expr2 asLowercase '
                   with: ' `@expr1 startsWith: `@expr2 caseSensitive: false ' ;

                replace: ' `@expr1 asLowercase endsWith: `@expr2 asLowercase '
                   with: ' `@expr1 endsWith: `@expr2 caseSensitive: false '; 

                replace: ' `@expr1 asUppercase startsWith: `@expr2 asUppercase '
                   with: ' `@expr1 startsWith: `@expr2 caseSensitive: false ' ;

                replace: ' `@expr1 asUppercase endsWith: `@expr2 asUppercase '
                   with: ' `@expr1 endsWith: `@expr2 caseSensitive: false ' 
! !

!RBUnneededAsLowercaseRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

