"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBParseTreeLintRule subclass:#RBUsesValueOfNextPutRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBUsesValueOfNextPutRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) 2019 Claus Gittinger

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBUsesValueOfNextPutRule methodsFor:'accessing'!

group
    ^ 'Possible Bugs'
!

name
    ^ 'Uses the result of a "nextPut:"-like message'

    "Modified: / 01-03-2012 / 11:27:22 / cg"
!

rationale
    ^ 'Check for possible uses of the result returned by "<code>nextPut:</code>" and similar stream messages. 
It seems that not all streams return the same value (some the arg, some the receiver).
Please check the code if the value returned is correct,
and/or change the code to assign the argument to a variable instead.'

    "Modified: / 01-03-2012 / 12:17:42 / cg"
! !

!RBUsesValueOfNextPutRule methodsFor:'initialization'!

checkMethod: aContext
    |mthd|

    mthd := aContext compiledMethod.

    "a quick rejector, to avoid many parses (because parsing is very slow)"
    (mthd sendsAnySelector:#(#'nextPutAll:' #'nextPut:' )) ifFalse:[^ self].

    ^ super checkMethod: aContext
!

initialize
    super initialize.
    self matcher 
            matches: '`{:node | 
                            node isMessage 
                                and: [ ( #(#''nextPut:'' #''nextPutAll:'') includes:node selector)
                                and: [node isDirectlyUsed]]
                       }'
            do: [ :node :answer | node ]
! !

!RBUsesValueOfNextPutRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

