"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBBlockLintRule subclass:#RBUtilityMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!

!RBUtilityMethodsRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBUtilityMethodsRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Utility methods'
!

rationale
        ^ 'Utility methods have one or more arguments and do no refer to self 
or an instance variable. 
These methods might be better defined as class methods or in some other (utility-)class,
to allow for better reuse.
<P>
But make sure that the method is not part of a protocol between components, 
which is required by other parts of the system (for example: query or hook methods).
Especially by as-yet unloaded packages.'

    "Modified: / 01-03-2012 / 11:32:17 / cg"
! !

!RBUtilityMethodsRule methodsFor:'private'!

subclassOf: aClass overrides: aSelector 
        ^ aClass subclasses contains:[:each | 
                        (each includesSelector: aSelector)
                                or: [self subclassOf: each overrides: aSelector]]

    "Modified: / 24-05-2018 / 20:48:00 / Claus Gittinger"
!

utilityProtocols
	^ #('*utilit*')
! !

!RBUtilityMethodsRule methodsFor:'running'!

checkMethod: aContext
    |cls selector|

    cls := aContext selectedClass.
    selector := aContext selector.

    (cls isMeta 
    or:[ selector argumentCount == 0 
    or:[ 
        (aContext protocols 
            contains:[:each | 
                self utilityProtocols 
                    contains:[:protocol | protocol match: each]
                ]
        )  
    ]]) ifFalse:[ 
        (self subclassOf: cls overrides: selector) ifFalse:[ 
            (aContext superMessages isEmpty and: [ aContext selfMessages isEmpty ]) ifTrue:[ 
                 (cls allInstVarNames , cls allClassVarNames asArray , #('self' ) 
                        detect: [ :each | aContext parseTree references: each ]
                        ifNone: [  ]
                ) isNil ifTrue:[ 
                    result addClass: cls selector: selector 
                ] 
            ] 
        ] 
    ]

    "Modified: / 24-05-2018 / 20:49:43 / Claus Gittinger"
! !

!RBUtilityMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

