"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

"{ NameSpace: Smalltalk }"

RBTransformationRule subclass:#RBWrongResourceTranslationsReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!

!RBWrongResourceTranslationsReplaceRule class methodsFor:'documentation'!

copyright
"
 Copyright (C) Original SmallLint Authors
 Copyright (C) The Squeak Team
 Copyright (C) The Pharo Team
 Copyright (C) 2011-2013 Jan Vrany (porting, Smalltalk/X rules & tweaks)
 Copyright (C) 2011-2013 Claus Gittinger (porting, Smalltalk/X rules & tweaks)

 Permission is hereby granted, free of charge, to any 
 person obtaining a copy of this software and associated 
 documentation files (the 'Software'), to deal in the 
 Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, 
 sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, 
 subject to the following conditions:

 The above copyright notice and this permission notice shall 
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBWrongResourceTranslationsReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 19:42:09 / cg"
!

name
    ^ 'Fix wrong use of resource translations (ST/X specific)'

    "Modified: / 01-03-2012 / 19:39:38 / cg"
    "Modified: / 28-05-2019 / 07:47:24 / Claus Gittinger"
!

rationale
        ^ 'Checks for code like:
<code>(resources string:''... %1 ...'') bindWith:foo</code>
which should be written as:
<code>(resources string:''... %1 ...'' with:foo</code>)
'

    "Created: / 01-03-2012 / 19:39:24 / cg"
    "Modified: / 28-05-2019 / 07:49:10 / Claus Gittinger"
! !

!RBWrongResourceTranslationsReplaceRule methodsFor:'initialization'!

initialize
        super initialize.
        self rewriteRule
                replace: '(resources stringWithCRs:`#format) bindWith:`@arg'
                        with: '(resources stringWithCRs:`#format with:`@arg)';

                replace: '(resources string:`#format) bindWith:`@arg'
                        with: '(resources stringWithCRs:`#format with:`@arg)';

                replace: '(`@x resources stringWithCRs:`#format) bindWith:`@arg'
                        with: '(`@x resources stringWithCRs:`#format with:`@arg)';

                replace: '(`@x resources string:`#format) bindWith:`@arg'
                        with: '(`@x resources stringWithCRs:`#format with:`@arg)'

    "Modified: / 01-03-2012 / 19:41:59 / cg"
    "Modified: / 28-05-2019 / 07:52:22 / Claus Gittinger"
! !

!RBWrongResourceTranslationsReplaceRule methodsFor:'running'!

shouldIgnoreClass: aClass selector: selector
    aClass isTestCaseLike ifTrue:[^ true].
    ^ super shouldIgnoreClass:aClass selector:selector.
! !

!RBWrongResourceTranslationsReplaceRule class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

