"
COPYRIGHT (c) 2022 LabWare


 Permission is hereby granted, free of charge, to any
 person obtaining a copy of this software and associated
 documentation files (the 'Software'), to deal in the
 Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute,
 sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/parser' }"

"{ NameSpace: Smalltalk }"

Object subclass:#RBToken
	instanceVariableNames:'sourcePointer lineNumber columnNumber comments'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Scanner'
!

!RBToken class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2022 LabWare


 Permission is hereby granted, free of charge, to any
 person obtaining a copy of this software and associated
 documentation files (the 'Software'), to deal in the
 Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute,
 sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RBToken class methodsFor:'instance creation'!

start: anInterval 
	^self new start: anInterval
!

start: anInterval lineNumber: tokenLineNumber
	^self new start: anInterval lineNumber: tokenLineNumber
! !

!RBToken methodsFor:'accessing'!

columnNumber
    ^ columnNumber
!

columnNumber:something
    columnNumber := something.
!

comments
    ^ comments
!

comments:anObject
    comments := anObject.
!

endPosition
    ^ self stop
!

length
	^self subclassResponsibility
!

lineNumber
    lineNumber isNil ifTrue:[
        self breakPoint:#cg info:'lineNumber should always be non-nil'
    ].
    ^ lineNumber

    "Modified: / 26-04-2010 / 14:58:57 / sr"
    "Modified (format): / 11-10-2017 / 13:42:31 / cg"
!

lineNumber:something
    lineNumber := something.
    "/ self assert:(lineNumber notNil).
!

originalCodeIn:source
    ^ (source copyFrom:self start to:self stop) 
!

removePositions
	sourcePointer := nil
!

start
        ^sourcePointer ? 1
!

startPosition
    ^ self start
!

stop
        ^(sourcePointer ? 1) + self length - 1
! !

!RBToken methodsFor:'initialization & release'!

start: anInteger 
	sourcePointer := anInteger
!

start: anInteger lineNumber: tokenLineNumber
        sourcePointer := anInteger.
        lineNumber := tokenLineNumber.
        "/ self assert:(lineNumber notNil).
! !

!RBToken methodsFor:'printing'!

printOn: aStream 
        aStream
                nextPut: $ ;
                nextPutAll: self className

    "Modified: / 28-06-2019 / 09:07:35 / Claus Gittinger"
! !

!RBToken methodsFor:'testing'!

isAnySpecial:possibleChars
        ^false

    "Created: / 14-06-2020 / 13:25:14 / cg"
!

isAssignment
	^false
!

isBinary
	^false
!

isBinary:whichValue
        ^ false

    "Created: / 14-06-2020 / 13:14:29 / cg"
!

isEOF
    ^ self class == RBToken

    "Created: / 06-03-2012 / 11:20:54 / cg"
!

isIdentifier
	^false
!

isKeyword
	^false
!

isLiteral
	^false
!

isLiteralArray
        ^false
!

isLiteralByteArray
        ^false
!

isLiteralCString
        ^false

    "Created: / 17-02-2019 / 12:48:51 / Claus Gittinger"
!

isLiteralCharacter
        ^false
!

isLiteralEString
        ^false

    "Created: / 17-02-2019 / 12:48:51 / Claus Gittinger"
!

isLiteralFloat
        ^false
!

isLiteralIString
        ^false

    "Created: / 17-02-2019 / 12:48:51 / Claus Gittinger"
!

isLiteralInteger
        ^false
!

isLiteralNil
        ^false

    "Created: / 06-02-2017 / 14:57:41 / cg"
!

isLiteralNumber 
    ^ false
!

isLiteralRString
        ^false

    "Created: / 17-02-2019 / 12:48:51 / Claus Gittinger"
!

isLiteralString
        ^false
!

isLiteralSymbol
        ^false
!

isMetaVariable
	^false
!

isOldStyleAssignment
        ^false
!

isOptimized
	^false
!

isPatternBlock
	^false
!

isPatternVariable
	^false
!

isSTXPrimitiveCode
    ^ false
!

isSpecial
	^false
!

isSpecial:char
        ^false

    "Created: / 14-06-2020 / 13:26:42 / cg"
! !

!RBToken class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

