"{ Encoding: utf8 }"

"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

"{ NameSpace: Smalltalk }"

RestoringVariableRefactoring subclass:#PushDownInstanceVariableRefactoring
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Refactorings'
!


!PushDownInstanceVariableRefactoring methodsFor:'preconditions'!

preconditions
        | references |
        references := RBCondition referencesInstanceVariable: variableName
                                in: class.
        class realClass isNil 
                ifTrue: 
                        [references 
                                errorMacro: ('<1s> is referenced.' expandMacrosWith: variableName)]
                ifFalse: 
                        [references
                                errorMacro: ('<1s> is referenced.<n>Browse references?' 
                                                        expandMacrosWith: variableName);
                                errorBlock: 
                                                [self openBrowserOn: (BrowserEnvironment new instVarRefsTo: variableName
                                                                        in: class realClass)]].
        ^(RBCondition definesInstanceVariable: variableName in: class) 
                & references not
! !

!PushDownInstanceVariableRefactoring methodsFor:'transforming'!

transform
        class removeInstanceVariable: variableName.
        class subclasses do:[:each | 
            (each withAllSubclasses 
                contains:[:aClass | 
                            (aClass whichSelectorsReferToInstanceVariable: variableName) isEmpty not]
            ) ifTrue: [
                each addInstanceVariable: variableName
            ]
        ]

    "Modified: / 24-05-2018 / 20:57:15 / Claus Gittinger"
! !

!PushDownInstanceVariableRefactoring class methodsFor:'documentation'!

version
    ^ '$Header$'
! !

