"
COPYRIGHT (c) 2022 LabWare


 Permission is hereby granted, free of charge, to any
 person obtaining a copy of this software and associated
 documentation files (the 'Software'), to deal in the
 Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute,
 sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

"{ NameSpace: Smalltalk }"

Refactoring subclass:#RemoveClassRefactoring
	instanceVariableNames:'classNames'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Refactorings'
!

!RemoveClassRefactoring class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2022 LabWare


 Permission is hereby granted, free of charge, to any
 person obtaining a copy of this software and associated
 documentation files (the 'Software'), to deal in the
 Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute,
 sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall
 be included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!RemoveClassRefactoring class methodsFor:'instance creation'!

className: aSymbol
	^self classNames: (Array with: aSymbol)
!

classNames: aClassNameCollection 
	^self new classNames: aClassNameCollection
!

model: aRBSmalltalk classNames: aClassNameCollection 
	^(self new)
		model: aRBSmalltalk;
		classNames: aClassNameCollection;
		yourself
! !

!RemoveClassRefactoring methodsFor:'initialize-release'!

classNames: aClassNameCollection 
	classNames := aClassNameCollection
! !

!RemoveClassRefactoring methodsFor:'preconditions'!

hasReferencesTo: aSymbol 
        | literal |
        literal := Smalltalk associationAt: aSymbol.

        BrowserEnvironment new classesDo: 
                        [:each | 
                        (classNames 
                                includes: (each isMeta ifTrue: [each soleInstance] ifFalse: [each]) name) 
                                        ifFalse: 
                                                [((Smalltalk respondsTo:#isSmalltalkX) and:[Smalltalk isSmalltalkX])
                                                 ifTrue:[
                                                    (each whichSelectorsReferToGlobal:aSymbol) isEmpty ifFalse: [^true].
                                                 ] ifFalse:[
                                                    (each whichSelectorsReferTo: literal) isEmpty ifFalse: [^true].
                                                 ].
                                                (each whichSelectorsReferTo: aSymbol) isEmpty ifFalse: [^true]]].
        ^false
!

preconditions
        ^classNames 
            inject: RBCondition empty
            into:[:sum :each | 
                | aClass |

                aClass := self model classNamed: each asSymbol.
                aClass isNil ifTrue: [self refactoringError: 'No such class'].
                "/ notice & and | mean something completly different here    
                sum 
                    & (((RBCondition isMetaclass: aClass) 
                                    errorMacro: 'Cannot remove just the metaclass') not 
                    & ((RBCondition withBlock: [(self hasReferencesTo: each asSymbol) not])
                                    errorMacro: each , ' is referenced.<n>Browse references?';
                                    errorBlock:[self openBrowserOn: (BrowserEnvironment new referencesTo: (Smalltalk associationAt: each ifAbsent: [each]))];
                                    yourself) 
                    & ((RBCondition hasSubclasses: aClass) not 
                        | ((RBCondition isEmptyClass: aClass) 
                            & ((RBCondition withBlock: [aClass superclass notNil])
                                            errorMacro: 'Cannot remove top level class<n>when it has subclasses';
                                            yourself))))
            ]
! !

!RemoveClassRefactoring methodsFor:'printing'!

changeString
    classNames size == 1 ifTrue: [
        ^ 'Remove class ', classNames anyOne.
    ] ifFalse: [ 
        ^ String streamContents: [ :s |
            s nextPutAll: 'Remove classes '.
            classNames do: [:name | s nextPutAll: name ]
              separatedBy: [ s nextPutAll: ', ' ].
        ].
    ].

    "Created: / 01-09-2022 / 11:26:13 / Jan Vrany <jan.vrany@labware.com>"
! !

!RemoveClassRefactoring methodsFor:'printing & storing'!

storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' classNames: '.
	classNames asArray storeOn: aStream.
	aStream nextPut: $)
! !

!RemoveClassRefactoring methodsFor:'transforming'!

removeClasses
	classNames do: [:each | self model removeClassNamed: each]
!

reparentSubclasses
	classNames do: 
			[:each | 
			| class |
			class := self model classNamed: each.
			self model reparentClasses: class subclasses copy to: class superclass]
!

transform
	self
		reparentSubclasses;
		removeClasses
! !

!RemoveClassRefactoring class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

