"{ Encoding: utf8 }"

"{ Package: 'stx:goodies/refactoryBrowser' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser class methodsFor:'documentation'!

documentation
"
    Package documentation:

    This package bundles the individual refactory browser packages.

    Its origins are refactory browser by Don Roberts and John Brant,
    and has been ported and integrated into ST/X by Claus Gittinger and Jan Vrany.
    See http://www.refactory.com/tools/refactoring-browser
"
! !

!stx_goodies_refactoryBrowser class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     When loading whole packages,
     mandatoryPreRequisites will be automatically loaded
     BEFORE this packet has been loaded. 
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes.
     Please take a look at the #referencedPreRequisites method as well."

    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_refactoryBrowser"
    )
!

subProjects
    "list packages which are known as subprojects.
    The generated makefile will enter those and make there as well.
    However: they are not forced to be loaded when a package is loaded;
    for those, redefine requiredPrerequisites"

    ^ #(
        #'stx:goodies/refactoryBrowser/helpers'
        #'stx:goodies/refactoryBrowser/parser'
        #'stx:goodies/refactoryBrowser/matching'
        #'stx:goodies/refactoryBrowser/changes'
        #'stx:goodies/refactoryBrowser/refactoring'
        #'stx:goodies/refactoryBrowser/browser'
        #'stx:goodies/refactoryBrowser/lint'
    )
! !

!stx_goodies_refactoryBrowser class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'stx_goodies_refactoryBrowser'
    )
! !

!stx_goodies_refactoryBrowser class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2013\nCopyright eXept Software AG 1998-2013'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_refactoryBrowser class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

